/*
 * Copyright (C) 2016 favdb
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package dico;

import java.io.BufferedReader;
import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.text.MessageFormat;
import java.util.ArrayList;
import java.util.List;
import java.util.Locale;
import java.util.MissingResourceException;
import java.util.ResourceBundle;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;

/**
 *
 * @author favdb
 */
public class Build extends javax.swing.JDialog {
	List<Language> languages=new ArrayList<>();
	/**
	 * Creates new form BuildDict
	 * @param parent
	 * @param modal
	 */
	public Build(java.awt.Frame parent, boolean modal) {
		super(parent, modal);
		initComponents();
		initUI();
	}

	/**
	 * This method is called from within the constructor to initialize the form. WARNING: Do NOT modify this code. The
	 * content of this method is always regenerated by the Form Editor.
	 */
	@SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLabel3 = new javax.swing.JLabel();
        cbLanguage = new javax.swing.JComboBox<>();
        btSelectFile = new javax.swing.JButton();
        jLabel2 = new javax.swing.JLabel();
        txFile = new javax.swing.JTextField();
        btBuild = new javax.swing.JButton();
        btQuit = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        java.util.ResourceBundle bundle = java.util.ResourceBundle.getBundle("dico/resources"); // NOI18N
        setTitle(bundle.getString("dlg.build.title")); // NOI18N

        jLabel3.setText(bundle.getString("dlg.build.selectlang")); // NOI18N

        cbLanguage.setMaximumRowCount(10);
        cbLanguage.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));

        btSelectFile.setIcon(new javax.swing.ImageIcon(getClass().getResource("/dico/img/file-open.png"))); // NOI18N
        btSelectFile.setToolTipText(bundle.getString("dlg.build.select")); // NOI18N
        btSelectFile.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btSelectFileActionPerformed(evt);
            }
        });

        jLabel2.setText(bundle.getString("dlg.build.sourcename")); // NOI18N

        btBuild.setText(bundle.getString("dlg.build.build")); // NOI18N
        btBuild.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btBuildActionPerformed(evt);
            }
        });

        btQuit.setText(bundle.getString("dlg.build.cancel")); // NOI18N
        btQuit.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btQuitActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addGap(0, 0, Short.MAX_VALUE)
                        .addComponent(btBuild, javax.swing.GroupLayout.PREFERRED_SIZE, 181, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(btQuit, javax.swing.GroupLayout.PREFERRED_SIZE, 140, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jLabel3)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(cbLanguage, javax.swing.GroupLayout.PREFERRED_SIZE, 256, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(0, 109, Short.MAX_VALUE))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jLabel2)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(txFile)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(btSelectFile)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.CENTER)
                    .addComponent(jLabel3)
                    .addComponent(cbLanguage, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.CENTER)
                    .addComponent(btSelectFile)
                    .addComponent(jLabel2)
                    .addComponent(txFile, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(btBuild)
                    .addComponent(btQuit))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void btSelectFileActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btSelectFileActionPerformed
		JFileChooser fc=new JFileChooser();
		fc.setCurrentDirectory(new File("."));
		int ret = fc.showOpenDialog(null);
		if (ret == JFileChooser.APPROVE_OPTION) {
			File file = fc.getSelectedFile();
			if (!file.exists()) {
				JOptionPane.showMessageDialog(null,
						I18N.getMsg("dlg.build.notexits.file", file),
						I18N.getMsg("dlg.build.notexits.title"),
						JOptionPane.ERROR_MESSAGE);
				return;
			}
			txFile.setText(file.getAbsolutePath());
		}
    }//GEN-LAST:event_btSelectFileActionPerformed

    private void btBuildActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btBuildActionPerformed
		int i=cbLanguage.getSelectedIndex();
		if (i==-1) {
			//no language selected
			return;
		}
		String code=languages.get(i).code;
		String language=languages.get(i).name;
		String inFile=txFile.getText();
		if (inFile.isEmpty()) {
			//missing infile name
			return;
		}
		System.out.printf("build for %s as %s\n", code, language);
		Exec build=new Exec(this,code, inFile);
		build.exec();
		dispose();
    }//GEN-LAST:event_btBuildActionPerformed

    private void btQuitActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btQuitActionPerformed
		dispose();
		System.exit(0);
    }//GEN-LAST:event_btQuitActionPerformed

	/**
	 * @param args the command line arguments
	 */
	public static void main(String args[]) {
		/* Set the Nimbus look and feel */
		//<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
		/* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
		 */
		try {
			for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
				if ("Nimbus".equals(info.getName())) {
					javax.swing.UIManager.setLookAndFeel(info.getClassName());
					break;
				}
			}
		} catch (ClassNotFoundException | InstantiationException | IllegalAccessException | javax.swing.UnsupportedLookAndFeelException ex) {
			java.util.logging.Logger.getLogger(Build.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
		}
		//</editor-fold>
		//</editor-fold>
		
		//</editor-fold>

		/* Create and display the dialog */
		java.awt.EventQueue.invokeLater(() -> {
			Build dialog = new Build(new javax.swing.JFrame(), true);
			dialog.addWindowListener(new java.awt.event.WindowAdapter() {
				@Override
				public void windowClosing(java.awt.event.WindowEvent e) {
					System.exit(0);
				}
			});
			dialog.setVisible(true);
		});
	}

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btBuild;
    private javax.swing.JButton btQuit;
    private javax.swing.JButton btSelectFile;
    private javax.swing.JComboBox<String> cbLanguage;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JTextField txFile;
    // End of variables declaration//GEN-END:variables

	@SuppressWarnings("unchecked")
	private void initUI() {
		this.setLocationRelativeTo(null);
		//load cbLanguage
		languages = new ArrayList<>();
		languages.add(new Language("",""));
		InputStream stream = this.getClass().getResourceAsStream("languages.txt");
		BufferedReader txt = new BufferedReader(new InputStreamReader(stream));
		String line = null;
		try {
			line = txt.readLine();
		} catch (IOException ex) {
			Logger.getLogger(Build.class.getName()).log(Level.SEVERE, null, ex);
		}
		while (line != null) {
			String[] s = line.split(",");
			if (s.length==2) languages.add(new Language(s[1], s[0]));
			try {
				line = txt.readLine();
			} catch (IOException ex) {
				Logger.getLogger(Build.class.getName()).log(Level.SEVERE, null, ex);
			}
		}
		DefaultComboBoxModel model=new DefaultComboBoxModel();
		for (Language l:languages) {
			model.addElement(l.name);
		}
		cbLanguage.setModel(model);
	}

	public class Language {

		String name, code;

		private Language(String n, String c) {
			name=n;
			code=c;
		}
	}
}
